unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Db, DBTables, DBCtrls, FFDB,
  ffkonfcmp, Mask, Buttons, CPFDBInsp, Menus;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    PopupMenu1: TPopupMenu;
    Edit1: TMenuItem;
    Panel1: TPanel;
    CPFDBInspector1: TCPFDBInspector;
    Label1: TLabel;
    ComboBox1: TComboBox;
    Database1: TDatabase;
    DBNavigator1: TDBNavigator;
    procedure FormCreate(Sender: TObject);
	 procedure cpfDBInspector1EditChange(Sender: TObject; Field: TField;
	   CurrentText: String; var AllowEdit, Error: Boolean);
    procedure CPFDBInspector1ItemNotify(Sender: TObject; AField: TField;
      Event: TDBInspectorItemEvent; const X, Y: Integer);
    function CPFDBInspector1GetShowClass(Sender: TObject; AField: TField;
      var AHeight: Integer): TBaseInspectorControlClass;
    procedure ComboBox1Change(Sender: TObject);
  private
	 { Private-Deklarationen }
  protected
  public
	 { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
	  CPFDBInspector1.align := alclient;
	  with ComboBox1 do
	  begin
		   database1.connected := true;
		   database1.session.gettablenames(database1.Aliasname, '', true, false, items);
		   itemindex := items.indexof(table1.tablename);
	  end;
	  table1.active := true;
end;

procedure TForm1.cpfDBInspector1EditChange(Sender: TObject; Field: TField;
  CurrentText: String; var AllowEdit, Error: Boolean);
var
	i : integer;
begin
	  if field.datatype = ftinteger then
	  begin
		   try
			 i := strtoint(currenttext);
		   except
			 error := true;
		   end;
	  end;
end;

procedure TForm1.CPFDBInspector1ItemNotify(Sender: TObject; AField: TField;
  Event: TDBInspectorItemEvent; const X, Y: Integer);
var
	s : string;
begin
	  case event of
		DBIDblClick: s := 'dblclicked';
		dbirightmouse: s := 'dbirightmouse';
		dbileftmouse: s := 'dbileftmouse'
		else s := 'Unknown';
	  end;
	  // show the image-window here
	  //showmessage(format('%s: %s',[s,afield.fieldname]));
	  if event = dbirightmouse then
	  begin

		PopupMenu1.popup(x,y);
	  end;
end;

function TForm1.CPFDBInspector1GetShowClass(Sender: TObject;
  AField: TField; var AHeight: Integer): TBaseInspectorControlClass;
begin
     result := nil;
	  if (AField.datatype = ftblob) or (AField.datatype = ftGraphic) or (AField.fieldname = 'BMP') then
	  begin
		aheight := 100;
		result := TPictureInspectorControl;
	  end;
	  if AField.DataType in [ftTypedBinary, ftBlob, ftMemo, ftFmtMemo] then
	  begin
		aheight := 60;
	  end;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var
	tn : string;
begin
	  if combobox1.itemindex < 0 then exit;
	  try
		tn := combobox1.items[combobox1.itemindex];
	  except
		exit;
	  end;
	  table1.active := false;
	  table1.tablename := tn;
	  table1.active := true;
end;

end.
